"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _q3UiForms = require("q3-ui-forms");

var _usefulState = require("useful-state");

var _lodash = require("lodash");

var _Save = _interopRequireDefault(require("@material-ui/icons/Save"));

var _Close = _interopRequireDefault(require("@material-ui/icons/Close"));

var _q3UiLocale = require("q3-ui-locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const Editable = ({
  label,
  name,
  initialValues,
  onSubmit,
  text,
  ...rest
}) => {
  const {
    open,
    close,
    anchorEl,
    isOpen
  } = (0, _usefulState.useOpen)();
  const {
    t
  } = (0, _q3UiLocale.useTranslation)('labels');

  _react.default.useEffect(() => close, []);

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_core.Box, {
    className: "q3-popover-trigger",
    component: "span",
    onClick: open,
    onKeyPress: open,
    role: "button",
    style: {
      cursor: 'pointer',
      textDecoration: 'underline',
      textDecorationStyle: 'dotted'
    },
    tabIndex: 0
  }, text), /*#__PURE__*/_react.default.createElement(_core.Popover, {
    disablePortal: true,
    open: isOpen,
    anchorEl: anchorEl,
    onClose: close,
    anchorOrigin: {
      vertical: 'top',
      horizontal: 'left'
    },
    transformOrigin: {
      vertical: 'top',
      horizontal: 'left'
    }
  }, /*#__PURE__*/_react.default.createElement(_core.Box, {
    p: 1,
    maxWidth: "80vw",
    width: 320
  }, /*#__PURE__*/_react.default.createElement(_q3UiForms.Builders.Form, _extends({}, (0, _lodash.pick)(rest, ['collectionName', 'isNew', 'initialErrors', 'debug', 'keep', 'marshal', 'marshalAuthorizationContext', 'marshalSelectively', 'modify', 'showSuccessMessage', 'restart', 'translate', 'onReset', 'unwind', 'under']), {
    disableChangeDetection: true,
    enableSubmit: false,
    initialValues: initialValues,
    onSubmit: onSubmit
  }), (_v, _e, {
    isModified
  }) => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: 12,
    style: {
      marginBottom: '-.5rem'
    }
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    container: true,
    justifyContent: "space-between"
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_core.Typography, {
    variant: "overline"
  }, t(label || name))), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_core.IconButton, {
    "aria-label": "close",
    onClick: close
  }, /*#__PURE__*/_react.default.createElement(_Close.default, null))))), /*#__PURE__*/_react.default.createElement(_q3UiForms.Builders.Field, _extends({}, (0, _lodash.pick)(rest, ['name', 'type', 'override', 'under', 'options', 'loadOptions', 'min', 'max', 'step', 'validate', 'freeSolo', 'positive', 'variant', 'required', 'of', 'multiline', 'rows', 'runOnChange', 'preload', 'minimumCharacterCount', 'initialValue', 'disabled', 'label', 'onChange', 'getOptionDisabled', 'renderOption', 'readOnly', 'required', 'freeSolo', 'disabled', 'maxVisible']), {
    name: name,
    autoFocus: true,
    suppressLabel: true,
    suppressHelper: true,
    xl: 12,
    lg: 12
  })), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: 12,
    style: {
      marginTop: '-.5rem'
    }
  }, /*#__PURE__*/_react.default.createElement(_core.Button, {
    disabled: !isModified,
    "aria-label": "save",
    startIcon: /*#__PURE__*/_react.default.createElement(_Save.default, null),
    type: "submit"
  }, t('save'))))))));
};

Editable.defaultProps = {
  label: undefined,
  text: '--',
  initialValues: {}
};
Editable.propTypes = {
  label: _propTypes.default.string,
  name: _propTypes.default.string.isRequired,
  // eslint-disable-next-line
  initialValues: _propTypes.default.object,
  onSubmit: _propTypes.default.func.isRequired,
  text: _propTypes.default.string
};

var _default = /*#__PURE__*/_react.default.memo(Editable);

exports.default = _default;